<template>
    <div class="order">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col cols="9">
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.ORDER') }} #
                            {{ selectedOrder }}
                        </h1>
                        <v-breadcrumbs
                            ><v-breadcrumbs-item
                                class="text-red pointer"
                                @click="goToPage(menus.ORDERS.id)"
                                >{{
                                    $t('dashboard.menu.ORDERS')
                                }}</v-breadcrumbs-item
                            ><v-breadcrumbs-divider>/</v-breadcrumbs-divider>
                            <v-breadcrumbs-item disabled>{{
                                $t('dashboard.menu.ORDERDETAILS') +
                                ' ' +
                                selectedOrder
                            }}</v-breadcrumbs-item></v-breadcrumbs
                        >
                    </v-col>
                </v-row>

                <v-row
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16 pb-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col cols="12" md="8">
                        <v-row>
                            <v-col cols="12" class="pt-0"
                                ><v-card class="mx-auto">
                                    <v-list-item two-line>
                                        <v-list-item-content>
                                            <v-list-item-title
                                                class="font-syne-bold"
                                            >
                                                {{ $t('orders.summary') }}
                                            </v-list-item-title>
                                        </v-list-item-content>
                                    </v-list-item>

                                    <v-card-text>
                                        <v-row v-if="dataLoad">
                                            <v-col cols="12" md="2">
                                                <v-skeleton-loader
                                                    id="dataLoader"
                                                    :loading="dataLoading"
                                                    class="mx-auto"
                                                    max-width="auto"
                                                    type="avatar"
                                                />
                                            </v-col>
                                            <v-col cols="12" md="9">
                                                <v-skeleton-loader
                                                    id="dataLoader"
                                                    :loading="dataLoading"
                                                    class="mx-auto"
                                                    max-width="auto"
                                                    type="paragraph"
                                                />
                                            </v-col>
                                        </v-row>
                                        <v-divider v-if="dataLoad" />
                                        <v-row v-if="dataLoad">
                                            <v-col cols="6" md="10">
                                                <v-skeleton-loader
                                                    id="dataLoader"
                                                    :loading="dataLoading"
                                                    class="mx-auto"
                                                    max-width="auto"
                                                    type="text"
                                                />
                                            </v-col>
                                            <v-col
                                                cols="6"
                                                md="2"
                                                class="d-flex justify-end"
                                            >
                                                <v-skeleton-loader
                                                    id="dataLoader"
                                                    :loading="dataLoading"
                                                    class="mx-auto"
                                                    max-width="auto"
                                                    type="text"
                                                />
                                            </v-col>
                                        </v-row>
                                        <v-row v-if="!dataLoad">
                                            <v-col
                                                v-for="(
                                                    detail, d
                                                ) in details.items"
                                                :key="'detail-' + d"
                                                cols="12"
                                                class="pb-0 pt-0"
                                                ><v-row
                                                    ><v-col
                                                        cols="12"
                                                        md="2"
                                                        class="mb-2"
                                                        ><v-img
                                                            :src="
                                                                detail.product
                                                                    .images[0]
                                                                    .url
                                                            "
                                                        />
                                                    </v-col>
                                                    <v-col cols="9">
                                                        <h1
                                                            class="
                                                                pt-3
                                                                font-syne-bold
                                                            "
                                                        >
                                                            {{
                                                                detail.product
                                                                    .brand.name
                                                            }}
                                                        </h1>
                                                        <p
                                                            class="
                                                                mt-1
                                                                font-metropolis-regular
                                                            "
                                                        >
                                                            {{
                                                                detail.product
                                                                    .name
                                                            }}
                                                        </p>
                                                        <p
                                                            class="
                                                                font-metropolis-regular
                                                            "
                                                        >
                                                            {{
                                                                detail.variant
                                                                    .name
                                                            }}
                                                        </p>
                                                    </v-col>
                                                    <v-col
                                                        class="
                                                            d-flex
                                                            align-center
                                                            justify-end
                                                        "
                                                    >
                                                        <p>
                                                            x
                                                            {{
                                                                detail.quantity
                                                            }}
                                                        </p>
                                                    </v-col>
                                                </v-row>
                                            </v-col></v-row
                                        >
                                        <v-divider
                                            v-if="!dataLoad"
                                            class="mt-5"
                                        />
                                        <v-row v-if="!dataLoad" class="mt-1">
                                            <v-col cols="6" md="10">
                                                <p>
                                                    {{ $t('orders.amount') }}
                                                </p>
                                            </v-col>
                                            <v-col
                                                cols="6"
                                                md="2"
                                                class="d-flex justify-end"
                                            >
                                                {{ currencyName }}
                                                {{ details.amount }}
                                            </v-col>
                                        </v-row>
                                    </v-card-text>
                                </v-card>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col md="12" cols="12">
                                <v-card class="mx-auto">
                                    <v-list-item two-line>
                                        <v-list-item-content>
                                            <v-list-item-title
                                                class="font-syne-bold"
                                            >
                                                {{ $t('orders.timeline') }}
                                            </v-list-item-title>
                                        </v-list-item-content>
                                    </v-list-item>

                                    <v-card-text v-if="dataLoad">
                                        <v-timeline align-top dense>
                                            <!-- ORDER CREATED -->
                                            <v-timeline-item
                                                v-for="n in 4"
                                                :key="'loader-' + n"
                                                small
                                                color="grey"
                                            >
                                                <div>
                                                    <div class="pt-1">
                                                        <v-skeleton-loader
                                                            id="dataLoader"
                                                            :loading="
                                                                dataLoading
                                                            "
                                                            class="mx-auto"
                                                            max-width="auto"
                                                            type="text"
                                                        />
                                                    </div>
                                                </div>
                                            </v-timeline-item>
                                        </v-timeline>
                                    </v-card-text>
                                    <v-card-text v-else>
                                        <v-timeline align-top dense>
                                            <!-- ORDER CREATED -->
                                            <v-timeline-item
                                                small
                                                color="green"
                                            >
                                                <div>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t('orders.created')
                                                        }}</strong>
                                                        @{{
                                                            $moment(
                                                                details.order_at
                                                            ).format(
                                                                'DD/MM/YYYY HH:mm:ss'
                                                            )
                                                        }}
                                                    </div>
                                                </div>
                                            </v-timeline-item>

                                            <!-- ORDER STATUS -->
                                            <v-timeline-item
                                                v-if="!details.shipped_at"
                                                small
                                                :color="
                                                    details.status.id === 1 ||
                                                    details.status.id === 3
                                                        ? 'yellow'
                                                        : details.status.id ===
                                                              2 ||
                                                          details.status.id ===
                                                              5
                                                        ? 'green'
                                                        : 'red'
                                                "
                                            >
                                                <div v-if="details.invoice">
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t('orders.success')
                                                        }}</strong>
                                                        @{{
                                                            $moment(
                                                                details.invoice
                                                                    .created_at
                                                            ).format(
                                                                'DD/MM/YYYY HH:mm:ss'
                                                            )
                                                        }}
                                                    </div>
                                                    <div class="caption">
                                                        <p>
                                                            {{ currencyName }}
                                                            {{
                                                                details.invoice
                                                                    .amount
                                                            }}
                                                        </p>
                                                        <v-chip
                                                            :color="
                                                                details.status
                                                                    .id === 1 ||
                                                                details.status
                                                                    .id === 3
                                                                    ? 'yellow'
                                                                    : details
                                                                          .status
                                                                          .id ===
                                                                          2 ||
                                                                      details
                                                                          .status
                                                                          .id ===
                                                                          5
                                                                    ? 'green'
                                                                    : 'red'
                                                            "
                                                            pill
                                                            >{{
                                                                details.status
                                                                    .name
                                                            }}</v-chip
                                                        >
                                                    </div>
                                                </div>
                                                <div v-else>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t(
                                                                'orders.orderId'
                                                            ) +
                                                            ' ' +
                                                            details.status.name
                                                        }}</strong>
                                                        @{{
                                                            $moment(
                                                                details.updated_at
                                                            ).format(
                                                                'DD/MM/YYYY HH:mm:ss'
                                                            )
                                                        }}
                                                    </div>
                                                    <div class="caption">
                                                        <p>
                                                            {{ details.reason }}
                                                        </p>
                                                    </div>
                                                </div>
                                            </v-timeline-item>

                                            <!-- ORDER APPROVED -->
                                            <v-timeline-item
                                                small
                                                :color="
                                                    details.approved_at
                                                        ? 'green'
                                                        : 'grey'
                                                "
                                            >
                                                <div>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t(
                                                                'orders.approved'
                                                            )
                                                        }}</strong>
                                                        <span
                                                            v-if="
                                                                details.approved_at
                                                            "
                                                        >
                                                            @{{
                                                                $moment(
                                                                    details.approved_at
                                                                ).format(
                                                                    'DD/MM/YYYY HH:mm:ss'
                                                                )
                                                            }}
                                                        </span>
                                                    </div>
                                                </div>
                                            </v-timeline-item>

                                            <!-- ORDER SHIPPING -->
                                            <v-timeline-item
                                                small
                                                :color="
                                                    details.shipping_at
                                                        ? 'green'
                                                        : 'grey'
                                                "
                                            >
                                                <div>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t(
                                                                'orders.shipping'
                                                            )
                                                        }}</strong>
                                                        <span
                                                            v-if="
                                                                details.shipping_at
                                                            "
                                                        >
                                                            @{{
                                                                $moment(
                                                                    details.shipping_at
                                                                ).format(
                                                                    'DD/MM/YYYY HH:mm:ss'
                                                                )
                                                            }}
                                                        </span>
                                                    </div>
                                                </div>
                                            </v-timeline-item>

                                            <!-- ORDER DELIVERED -->
                                            <v-timeline-item
                                                small
                                                :color="
                                                    details.shipped_at
                                                        ? 'green'
                                                        : 'grey'
                                                "
                                            >
                                                <div>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t(
                                                                'orders.delivered'
                                                            )
                                                        }}</strong>
                                                        <span
                                                            v-if="
                                                                details.returned_at
                                                            "
                                                        >
                                                            @{{
                                                                $moment(
                                                                    details.returned_at
                                                                ).format(
                                                                    'DD/MM/YYYY HH:mm:ss'
                                                                )
                                                            }}
                                                        </span>
                                                    </div>
                                                </div>
                                            </v-timeline-item>

                                            <!-- ORDER PICK UP REQUESTED -->
                                            <v-timeline-item
                                                v-if="
                                                    details.business_type_id !=
                                                    2
                                                "
                                                small
                                                :color="
                                                    details.pick_up_requested_at
                                                        ? 'green'
                                                        : 'grey'
                                                "
                                            >
                                                <div>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t(
                                                                'orders.pickUpRequested'
                                                            )
                                                        }}</strong>
                                                        <span
                                                            v-if="
                                                                details.pick_up_requested_at
                                                            "
                                                        >
                                                            @{{
                                                                $moment(
                                                                    details.pick_up_requested_at
                                                                ).format(
                                                                    'DD/MM/YYYY HH:mm:ss'
                                                                )
                                                            }}
                                                        </span>
                                                    </div>
                                                </div>
                                            </v-timeline-item>

                                            <!-- ORDER RETURN -->
                                            <v-timeline-item
                                                v-if="
                                                    details.business_type_id !=
                                                    2
                                                "
                                                small
                                                :color="
                                                    details.return_at
                                                        ? 'green'
                                                        : 'grey'
                                                "
                                            >
                                                <div>
                                                    <div
                                                        class="
                                                            font-weight-normal
                                                        "
                                                    >
                                                        <strong>{{
                                                            $t(
                                                                'orders.returned'
                                                            )
                                                        }}</strong>
                                                    </div>
                                                </div>
                                            </v-timeline-item>
                                        </v-timeline>
                                    </v-card-text>
                                </v-card>
                            </v-col>
                        </v-row>
                    </v-col>

                    <v-col cols="12" md="4">
                        <v-card class="mx-auto">
                            <v-list-item two-line>
                                <v-list-item-content>
                                    <v-list-item-title class="font-syne-bold">
                                        {{ $t('orders.customerInfo') }}
                                    </v-list-item-title>
                                </v-list-item-content>
                            </v-list-item>

                            <v-card-text v-if="dataLoad">
                                <v-row>
                                    <v-col cols="12">
                                        <v-skeleton-loader
                                            id="dataLoader"
                                            :loading="dataLoading"
                                            class="mx-auto"
                                            max-width="auto"
                                            type="sentences"
                                        />
                                    </v-col>
                                </v-row>

                                <v-divider />
                                <v-row>
                                    <v-col cols="12">
                                        <v-skeleton-loader
                                            id="dataLoader"
                                            :loading="dataLoading"
                                            class="mx-auto"
                                            max-width="auto"
                                            type="paragraph"
                                        />
                                    </v-col>
                                </v-row>
                            </v-card-text>
                            <v-card-text v-else>
                                <v-row>
                                    <v-col>
                                        <h2 class="font-syne-bold">
                                            {{ details.user.profile.name }}
                                        </h2>
                                        <p
                                            v-if="details.user.profile.mobile"
                                            class="mt-1 font-metropolis-regular"
                                        >
                                            <v-icon small>mdi-phone</v-icon>
                                            {{ details.user.profile.mobile }}
                                        </p>
                                        <p
                                            v-if="details.user.email"
                                            class="mt-1 font-metropolis-regular"
                                        >
                                            <v-icon small>mdi-email</v-icon>
                                            {{ details.user.email }}
                                        </p>
                                    </v-col>
                                </v-row>
                                <v-divider />
                                <v-row>
                                    <v-list-item two-line>
                                        <v-list-item-content>
                                            <v-list-item-title
                                                class="font-syne-bold"
                                            >
                                                {{
                                                    $t('orders.shippingAddress')
                                                }}
                                            </v-list-item-title>
                                        </v-list-item-content>
                                    </v-list-item>
                                </v-row>
                                <v-row>
                                    <v-col>
                                        <p
                                            v-if="details.shipping_address"
                                            class="mb-0"
                                        >
                                            {{ details.shipping_address.name }}
                                        </p>
                                        <p
                                            v-if="details.shipping_address"
                                            class="mb-0"
                                        >
                                            {{
                                                details.shipping_address
                                                    .address_1
                                            }}
                                        </p>
                                        <p
                                            v-if="details.shipping_address"
                                            class="mb-0"
                                        >
                                            {{
                                                details.shipping_address
                                                    .address_2
                                                    ? details.shipping_address
                                                          .address_2 +
                                                      ', ' +
                                                      details.shipping_address
                                                          .city
                                                    : details.shipping_address
                                                          .city
                                            }}
                                        </p>
                                        <p
                                            v-if="details.shipping_address"
                                            class="mb-0"
                                        >
                                            {{
                                                details.shipping_address
                                                    .postcode +
                                                ', ' +
                                                details.shipping_address.state +
                                                ', ' +
                                                details.shipping_address.country
                                            }}
                                        </p>
                                        <p
                                            v-if="details.shipping_address"
                                            class="mb-0"
                                        >
                                            {{
                                                details.shipping_address.mobile
                                            }}
                                        </p>
                                        <v-btn
                                            v-if="cartItemsCF.length != 0"
                                            class="
                                                lowercase
                                                font-syne-bold
                                                mt-5
                                            "
                                            color="badge"
                                            @click="goToPage(menus2.CART.id)"
                                            >{{
                                                $t('buttons.returnBoxBtn')
                                            }}</v-btn
                                        >
                                    </v-col>
                                </v-row>
                            </v-card-text>
                        </v-card>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.ORDERS') + ' #' + this.selectedOrder,
            meta: [
                {
                    hid: 'description',
                    name: 'description',
                    content: this.productDescription,
                },
            ],
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        getAddress: 'user/getEditAddress',
        currency: 'currency/getCurrency',
        currencyName: 'currency/getCurrencyName',
        menus2: 'menu/getMenu',
        cartItems: 'cart/getCartItems',
        cartItemsCF: 'cart/getCartItemsCF',
    }),
})
export default class AddressEdit extends Vue {
    // Data
    menus!: any
    menus2!: any
    getAddress!: any
    dataLoad: boolean = true
    dataLoading: boolean = true
    selectedPage: Number = 3 // orders
    selectedOrder: Number = 1 // default order
    isAddAddressBtnDisabled: Boolean = false
    formHasErrors: Boolean = false
    details: any = {}

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.ORDERS.id:
                this.$router.push(this.menus.ORDERS.path)
                break

            case this.menus2.CART.id:
                this.$store.commit('drawerbar/setCartDrawer', true)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    getOrderDetails() {
        this.$api.order
            .getOrder(this.selectedOrder)
            .then((response) => {
                this.dataLoad = false
                this.dataLoading = false
                this.details = response.data
            })
            .catch((error) => {
                this.dataLoad = false
                this.dataLoading = false
                console.log(error)
            })
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
        this.selectedOrder = parseInt(this.$route.params.slug)

        // Get order details
        this.getOrderDetails()
    }
}
</script>
